#include <bits/stdc++.h>
using namespace std;

#ifndef LOCAL
#define cerr if(false) cerr
#endif // LOCAL
#define endl "\n"

#define out(x) "[ " << #x << " : " << x << " ]"

template<class T, class T2> inline bool chkmax(T &x, const T2 &y) { return (x < y) ? x = y, 1: 0; }
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) { return (x > y) ? x = y, 1: 0; }

typedef long long ll;
const ll mod = 1e9 + 7;
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

const ll MAX_N = 1e5 + 10;
vector<pair<ll, ll> > g[MAX_N];
ll n, m, s, t;
ll dist[MAX_N], par[MAX_N];
ll cool[MAX_N][2];
ll worst[MAX_N];

void bfs(ll s, ll blocked = -1) {
    for(ll i = 0; i <= n; i ++) {
        dist[i] = mod;
        par[i] = -1;
    }

    queue<ll> q;
    q.push(s);

    dist[s] = 0;
    par[s] = -1;

    while(!q.empty()) {
        auto curr = q.front(); q.pop();

        for(auto it : g[curr]) {
            if(it.second == blocked) {continue;}
            if(dist[it.first] == mod) {
                dist[it.first] = dist[curr] + 1;
                par[it.first] = it.second;
                q.push(it.first);
            }
        }
    }
}

void try_worst() {
    for(ll i = 0; i < n; i ++) {
        bfs(t, par[i]);
        for(ll j = 0; j < n; j ++) {
            chkmax(worst[j], dist[j]);
        }
    }
}

void bfs2(ll s) {
    for(ll i = 0; i <= n; i ++) {
        cool[i][0] = cool[i][1] = mod;
    }

    queue<pair<ll, ll> > q;

    cool[s][0] = 0;
    cool[s][1] = 0;
    q.push({s, 0});

    while(!q.empty()) {
        auto curr = q.front(); q.pop();

        for(auto it : g[curr.first]) {
            bool on = it.second == par[it.first];
            if(cool[it.first][on] == mod) {
                cool[it.first][on] = cool[curr.first][curr.second] + 1;
                q.push({it.first, on});
            }
        }
    }
}

bool can(ll s, ll t, ll x) {
    for(ll i = 0; i < n; i ++) {
        dist[i] = mod;
        par[i] = -1;
    }

    queue<ll> q;
    dist[s] = 0;
    q.push(s);

    while(!q.empty()) {
        auto curr = q.front(); q.pop();

        for(auto it : g[curr]) {
            ll possible = dist[curr] + 1 + worst[it.first];
            if(possible <= x) {
                if(dist[it.first] == mod) {
                    dist[it.first] = dist[curr] + 1;
                    par[it.first] = curr;
                    q.push(it.first);
                }
            }
        }
    }

    return dist[t] != mod;
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif // LOCAL

    cin >> n >> m >> s >> t;
    for(ll i = 0; i < m; i ++) {
        ll a, b;
        cin >> a >> b;
        g[a].push_back({b, i});
        g[b].push_back({a, i});
    }

    bfs(t);
    bfs2(t);
    try_worst();

    ll l = 0, r = mod;
    while(l < r - 1) {
        ll m = (l + r) / 2ll;
        if(can(s, t, m)) {
            r = m;
        } else {
            l = m;
        }
    }

    if(r == mod) {
        cout << -1 << endl;
        return 0;
    }

    can(s, t, r);
    vector<ll> ans = {};
    ll curr = t;
    while(curr != -1) {
        ans.push_back(curr);
        curr = par[curr];
    }

    reverse(ans.begin(), ans.end());

    cout << r << " " << ans.size() - 1 << endl;
    for(auto it : ans) {
        cout << it << " ";
    }

    return 0;
}

