#include <bits/stdc++.h>
using namespace std;

#ifndef LOCAL
#define cerr if(false) cerr
#endif // LOCAL
#define endl "\n"

#define out(x) "[ " << #x << " : " << x << " ]"

template<class T, class T2> inline bool chkmax(T &x, const T2 &y) { return (x < y) ? x = y, 1: 0; }
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) { return (x > y) ? x = y, 1: 0; }

typedef long long ll;
const ll mod = 1e9 + 7;
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

const ll MAX_N = 1e6 + 10;
vector<pair<ll, ll> > g[MAX_N];
ll n, m, s, t;
ll dist[MAX_N], par[MAX_N], start[MAX_N];
ll cool[MAX_N][2];
ll worst[MAX_N];
vector<int> poss;

void bfs(ll s, ll blocked = -1) {
    for(ll i = 0; i <= n; i ++) {
        dist[i] = mod;
        par[i] = -1;
    }

    queue<ll> q;
    q.push(s);

    dist[s] = 0;
    par[s] = -1;

    while(!q.empty()) {
        auto curr = q.front(); q.pop();

        for(auto it : g[curr]) {
            if(it.second == blocked) {continue;}
            if(dist[it.first] == mod) {
                dist[it.first] = dist[curr] + 1;
                par[it.first] = it.second;
                q.push(it.first);
            }
        }
    }
}

void try_worst() {
    for(ll i = 0; i < n; i ++) {
        start[i] = par[i];
    }
    for(ll i = 0; i < n; i ++) {
        bfs(t, start[i]);
        for(ll j = 0; j < n; j ++) {
            chkmax(worst[j], dist[j]);
        }
    }
    while(clock() < CLOCKS_PER_SEC * 3 / 2) {
        int rd = poss[rand() % poss.size()];
        bfs(t, rd);
        for(ll j = 0; j < n; j ++) {
            chkmax(worst[j], dist[j]);
        }
    }
}

bool can(ll s, ll t, ll x) {
    const ll inf = 1e18;
    for(ll i = 0; i < n; i ++) {
        dist[i] = inf;
        par[i] = -1;
    }

    queue<ll> q;
    dist[s] = 0;
    q.push(s);

    while(!q.empty()) {
        auto curr = q.front(); q.pop();

        for(auto it : g[curr]) {
            ll possible = dist[curr] + 1 + worst[it.first];
            if(possible <= x) {
                if(dist[it.first] == inf) {
                    dist[it.first] = dist[curr] + 1;
                    par[it.first] = curr;
                    q.push(it.first);
                }
            }
        }
    }

    return dist[t] != inf;
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif // LOCAL

    srand(time(NULL));

    set<pair<int, int> > st;

    cin >> n >> m >> s >> t;
    for(ll i = 0; i < m; i ++) {
        ll a, b;
        cin >> a >> b;
        g[a].push_back({b, i});
        g[b].push_back({a, i});
        if(a != b) {
            if(a > b) {swap(a, b);}
            st.insert({a, b});
        }
    }

    for(auto it : st) {
        poss.push_back({a, b});
    }

    bfs(t);
    if(dist[s] == mod) {
        cout << -1 << endl;
        return 0;
    }

    try_worst();

    if(s == t) {
        cout << 0 << " " << 1 << " " << s << endl;
        return 0;
    }

    ll l = 0, r = mod * 2;
    while(l < r - 1) {
        ll m = (l + r) / 2ll;
        if(can(s, t, m)) {
            r = m;
        } else {
            l = m;
        }
    }

    if(r == mod) {
        cout << -1 << endl;
        return 0;
    }

    can(s, t, r);
    vector<ll> ans = {};
    ll curr = t;
    while(curr != -1) {
        ans.push_back(curr);
        curr = par[curr];
    }

    reverse(ans.begin(), ans.end());

    cout << r << " " << ans.size() - 1 << endl;
    for(auto it : ans) {
        cout << it << " ";
    }

    return 0;
}
