#include <bits/stdc++.h>
using namespace std;

#ifndef LOCAL
#define cerr if(false) cerr
#endif // LOCAL
#define endl "\n"

#define out(x) "[ " << #x << " : " << x << " ]"

template<class T, class T2> inline bool chkmax(T &x, const T2 &y) { return (x < y) ? x = y, 1: 0; }
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) { return (x > y) ? x = y, 1: 0; }

typedef long long ll;
const ll mod = 1e9 + 7;
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

const int MAX_N = 5e3 + 10;
int n;
pair<pair<int, int>, int> p[MAX_N];

struct SegTree {
    int tree[4 * MAX_N];

    SegTree() {
        for(int i = 0; i < 4 * MAX_N; i ++) {
            tree[i] = -mod;
        }
    }

    void upd(int curr, int l, int r, int ind, int val) {
        if(l == r && l == ind) {
            chkmax(tree[curr], val);
            return;
        } else if(l > ind || r < ind) {
            return;
        }
        int m = (l + r) / 2ll;
        upd(curr * 2, l, m, ind, val);
        upd(curr * 2 + 1, m + 1, r, ind, val);
        tree[curr] = max(tree[curr * 2], tree[curr * 2 + 1]);
    }

    int ans(int curr, int l, int r, int ql, int qr) {
        if(r < l) {
            return 0;
        }
        if(ql <= l && r <= qr) {
            return tree[curr];
        } else if(l > qr || r < ql) {
            return -mod;
        }
        int m = (l + r) / 2ll;
        return max(ans(curr * 2, l, m, ql, qr), ans(curr * 2 + 1, m + 1, r, ql, qr));
    }
};

SegTree st[MAX_N];

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif // LOCAL

    cin >> n;
    for(int i = 0; i < n; i ++) {
        cin >> p[i].first.first >> p[i].first.second >> p[i].second;
        p[i].second --;
    }

    sort(p, p + n);

    vector<int> c;
    for(int i = 0; i < n; i ++) {
        c.push_back(p[i].first.second);
    }
    sort(c.begin(), c.end());
    c.resize(unique(c.begin(), c.end()) - c.begin());
    for(int i = 0; i < n; i ++) {
        p[i].first.second = lower_bound(c.begin(), c.end(), p[i].first.second) - c.begin();
    }

    ll ret = 0;

    st[0].upd(1, 0, MAX_N - 1, 0, 0);

    for(int i = 0; i < n; i ++) {
        for(int red = n; red >= 0; red --) {
            int who = st[red].ans(1, 0, MAX_N - 1, 0, p[i].first.second);
            chkmax(ret, who + 1);
            if(p[i].second) {
                st[red + 1].upd(1, 0, MAX_N - 1, p[i].first.second, who + 1);
            } else {
                st[red].upd(1, 0, MAX_N - 1, p[i].first.second, who + 1);
            }
        }
    }


    int small = mod;

    for(int i = 0; i <= n; i ++) {
        if(st[i].ans(1, 0, MAX_N - 1, 0, MAX_N - 1) == ret) {
            chkmin(small, abs(i - (ret - i)));
        }
    }

    cout << ret << " " << small << endl;

    return 0;
}

