#include <bits/stdc++.h>
using namespace std;

#ifndef LOCAL
#define cerr if(false) cerr
#endif // LOCAL
#define endl "\n"

#define out(x) "[ " << #x << " : " << x << " ]"

template<class T, class T2> inline bool chkmax(T &x, const T2 &y) { return (x < y) ? x = y, 1: 0; }
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) { return (x > y) ? x = y, 1: 0; }

typedef long long ll;
const ll mod = 1e9 + 7;
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

const ll MAX_N = 1e6 + 10;
ll arr[MAX_N];
ll n;
ll par[MAX_N], l[MAX_N], r[MAX_N], val[MAX_N];

ll find(ll x) {
    if(par[x] == x) {
        return x;
    } else {
        return par[x] = find(par[x]);
    }
}

bool merge(ll x, ll y) {
    x = find(x); y = find(y);

    if(x == y) {
        return false;
    }

    if(r[x] - l[x] < r[y] - l[y]) {
        swap(x, y);
    }

    par[y] = x;
    chkmin(l[x], l[y]);
    chkmax(r[x], r[y]);
    return true;
}

ll start[MAX_N];

ll solve(ll arr1, ll arrn, ll poss) {
    for(ll i = 1; i <= n; i ++) {
        arr[i] = start[i];
        par[i] = i;
        l[i] = i;
        r[i] = i;
    }
    arr[1] = arr1;
    arr[n] = arrn;

    for(ll i = 1; i < n; i ++) {
        if(arr[i] == arr[i + 1]) {
            merge(i, i + 1);
        }
    }

    arr[0] = mod;
    arr[n + 1] = mod;
    par[0] = 0;
    par[n + 1] = 0;

    set<pair<ll, ll> > st;
    auto try_to_add = [&](const ll i) {
        ll need = mod;
        if(arr[l[i] - 1] > arr[i]) { chkmin(need, arr[l[i] - 1]); } else { return; }
        if(arr[r[i] + 1] > arr[i]) { chkmin(need, arr[r[i] + 1]); } else { return; }

        if(need != mod) {
            st.insert({r[i] - l[i] + 1, i});
        }
    };

    for(ll i = 2; i <= n - 1; i ++) {
        if(find(i) == i) {
            try_to_add(i);
        }
    }

    while(poss && !st.empty()) {
        auto curr = *(st.begin());
        st.erase(st.begin());

        ll cost = curr.first;
        ll p = curr.second;

        ll need = mod;
        if(arr[find(l[p] - 1)] > arr[p]) { chkmin(need, arr[find(l[p] - 1)]); }
        if(arr[find(r[p] + 1)] > arr[p]) { chkmin(need, arr[find(r[p] + 1)]); }

        if((need - arr[p]) > poss / cost) {
            arr[p] += poss / cost;
            break;
        }

        poss -= (need - arr[p]) * cost;

        {
            ll lft = find(l[p] - 1);

            if(lft != 0 && arr[lft] == need) {
                auto it = st.find({r[lft] - l[lft] + 1, lft});
                if(it != st.end()) {
                    st.erase(it);
                }

                merge(p, lft);
                p = find(p);
                arr[p] = need;
                try_to_add(p);
            }
        }

        {
            ll rght = find(r[p] + 1);

            if(rght != 0 && arr[rght] == need) {
                auto it = st.find({r[rght] - l[rght] + 1, rght});
                if(it != st.end()) {
                    st.erase(it);
                }

                merge(p, rght);
                p = find(p);
                arr[p] = need;
                try_to_add(p);
            }
        }
    }

    ll sum = 0;
    for(ll i = 1; i <= n; i ++) {
        arr[i] = arr[find(i)];
    }
    for(ll i = 1; i < n; i ++) {
        sum += abs(arr[i + 1] - arr[i]);
    }
    return sum;
}

ll k;

void input() {
    cin >> n >> k;
    for(ll i = 1; i <= n; i ++) {
        cin >> start[i];
    }
}

ll solvefast() {
    ll ans = 1e18;
    for(ll l = 0; l <= k; l ++) {
        for(ll r = 0; r + l <= k; r ++) {
            chkmin(ans, solve(start[1] + l, start[n] + r, k - l - r));
        }
    }
    return ans;
}

const ll MAX_NN = 110, MAX_K = 250;
ll dp[MAX_NN][MAX_K][MAX_K];

ll solveslow() {
    for(int i = 0; i < n; i ++) {
        arr[i] = start[i + 1];
    }

    for(ll i = 0; i <= n; i ++) {
        for(ll j = 0; j <= k; j ++) {
            for(ll l = 0; l <= k; l ++) {
                dp[i][j][l] = 1e18;
            }
        }
    }

    for(ll i = 0; i <= k; i ++) {
        dp[0][i][i] = 0;
    }

    for(ll i = 1; i < n; i ++) {
        for(ll j = 0; j <= k; j ++) {
            for(ll l = j; l <= k; l ++) {
                for(ll r = 0; r <= k; r ++) {
                    chkmin(dp[i][j][l], dp[i - 1][r][l - j] + abs(arr[i - 1] + r - j - arr[i]));
                }
            }
        }
    }

    ll ret = 1e18;
    for(ll i = 0; i <= k; i ++) {
        for(ll j = 0; j <= k; j ++) {
            chkmin(ret, dp[n - 1][i][j]);
        }
    }

    return ret;
}

void test() {
    while(true) {
        n = 5, k = rand() % 20;
        for(int i = 1; i <= n; i ++) {
            start[i] = rand() % 50;
        }
        if(solvefast() != solveslow()) {
            cout << n << " " << k << endl;
            for(int i = 1; i <= n; i ++) {
                cout << start[i] << " ";
            }
            cout << endl;
            cout << solvefast() << " " << solveslow() << endl;
            exit(0);
        }
    }
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif // LOCAL

    ll t;

    cin >> t;
    while(t --) {
        input();
        cout << solvefast() << endl;
    }

    return 0;
}

/*
5 1
17 34 0 19 24
*/

/*
1
7
50
100 1 2 0 1 0 100
*/
