#include <bits/stdc++.h>
using namespace std;

const int maxn = 100005;
int n, m, s, t;
vector <pair <int, int> > adj [maxn];
int worst_distance [maxn];
bool visited [maxn];

void bfs (int e){
    for (int i = 0; i < n; i ++) visited [i] = 0;
    queue <pair <int, int> > q;
    q.push({t, 0});
    visited [t] = 1;
    while (!q.empty ()){
        auto u = q.front ();
        q.pop();
        worst_distance [u.first] = max (worst_distance [u.first], u.second);
        for (auto p : adj [u.first]){
            if (p.second == e) continue;
            if (!visited [p.first]){
                visited [p.first] = 1;
                q.push({p.first, u.second + 1});
            }
        }
    }
    for (int i = 0; i < n; i ++) if (!visited [i]) worst_distance [i] = 1000000000;
}

int par [maxn];
struct path{
    int u;
    int prev;
    int maxDist;
    bool operator < (path oth) const{
        return maxDist > oth.maxDist;
    }
};

int dijkstra(){
    for (int i = 0; i < n; i ++) visited [i] = 0;
    priority_queue<path> pq;
    pq.push({t, -1, 0});
    while (!pq.empty ()){
        auto p = pq.top ();
        pq.pop ();
        if (visited [p.u]) continue;
        visited [p.u] = 1;
        par [p.u] = p.prev;
        if (p.u == s) return p.maxDist;
        for (auto e : adj [p.u]){
            if (!visited [e.first]) pq.push({e.first, p.u, max (p.maxDist + 1, worst_distance [e.first])});
        }
    }
    return 1000000000;
}

int main (){

    //ios::sync_with_stdio (false);
    //cin.tie (0);

    cin >> n >> m >> s >> t;
    for (int i = 0; i < m; i ++){
        int u, v;
        cin >> u >> v;
        adj [u].push_back ({v, i});
        adj [v].push_back ({u, i});
    }
    for (int i = 0; i < m; i ++) bfs(i);
    int res = dijkstra();
    if (res >= 1000000000){
        cout << "-1\n";
        return 0;
    }
    vector <int> v;
    int i = s;
    while (i != -1){
        v.push_back (i);
        i = par [i];
    }
    cout << res << ' ' << v.size () - 1 << '\n';
    for (int x : v) cout << x << ' ';
    cout << '\n';

}
