// Gumza, ti li si be

#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#include <set>
#define int long long

const int maxn = 4000 + 10;
const int inf = 2e9;

int n, m, b, e;
std::vector < int > v[maxn], w[maxn], bcc;
std::vector < std::pair < int, int > > g[maxn];
std::set < std::pair < int, int > > bridges;

int multi[maxn][maxn];
bool call[maxn][maxn];
bool bl[maxn];
int t[maxn], low[maxn], timer;
bool findBridges(int x, int p)
{
    bl[x] = 1;
    t[x] = low[x] = ++timer;
    int cnt = 0;
    for (int i : v[x])
    {
        if (i == p)
        {
            ++cnt;
            continue;
        }

        if (bl[i])
        {
            low[x] = std::min(low[x], t[i]);
            continue;
        }

        bool res = findBridges(i, x);
        low[x] = std::min(low[i], low[x]);
        if (!res && low[i] > t[x])
        {
            bridges.insert({i, x});
            bridges.insert({x, i});
        }
    }

    return cnt >= 2;
}

void dfs(int x)
{
    bcc.push_back(x);
    bl[x] = 1;
    for (int i : w[x])
    {
        if (bl[i]) continue;
        dfs(i);
    }
}

int currD[maxn];
std::queue < int > q;
void findDists(int x, int y)
{
    // std::cout << "find dists: " << x << ' ' << y << '\n';
    while (!q.empty()) q.pop();
    for (int i : bcc) bl[i] = 0;
    bl[e] = 1; currD[e] = 0;
    q.push(e);
    while (!q.empty())
    {
        int top = q.front();
        q.pop();
        // std::cout << "top: " << top << ' ' << currD[top] << '\n';
        if (top == x) g[x].push_back({y, currD[x]});
        if (top == y) g[y].push_back({x, currD[y]});

        for (int i : w[top])
        {
            if (bl[i] || (std::min(i, top) == x && std::max(i, top) == y)) continue;
            bl[i] = 1;
            currD[i] = currD[top] + 1;
            q.push(i);
        }
    }
}

int currD2[maxn][maxn];
bool bl2[maxn][maxn];
int from[maxn][maxn];

struct element
{
    int x, dist, edges;
    inline friend bool operator < (element a, element b)
    {
        return a.dist > b.dist || (a.dist == b.dist && a.edges > b.edges);
    }
};

std::priority_queue < element > pq;
void dijkstra()
{
    for (int i = 0 ; i <= n ; ++i)
    {
        for (int j = 0 ; j <= n ; ++j)
        {
            currD2[i][j] = inf;
            bl2[i][j] = 0;
        }
    }
    currD2[b][0] = 0;
    pq.push({b, 0, 0});

    while (!pq.empty())
    {
        auto [top, dist, edges] = pq.top();
        pq.pop();
        // std::cout << "dijkstra: " << top << ' ' << dist << ' ' << edges << '\n';
        if (edges == n) continue;
        if (bl2[top][edges]) continue;
        bl2[top][edges] = 1;

        for (auto [i, ed] : g[top])
        {
            // std::cout << "here: " << i << ' ' << ed << ' ' << edges << ' ' << currD2[i][edges+1] << '\n';
            if (currD2[i][edges+1] > std::max(currD2[top][edges], ed + edges))
            {
                from[i][edges] = top;
                currD2[i][edges+1] = std::max(currD2[top][edges], ed + edges);
                pq.push({i, currD2[i][edges+1], edges+1});
            }
        }
    }
}

std::vector < int > ans;
void solve()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        for (int j : v[i])
        {
            int x = std::min(i, j);
            int y = std::max(i, j);
            if (multi[x][y] >= 0) continue;
            multi[x][y] = (multi[x][y] <= -2);
        }
    }

    findBridges(b, 0);
    for (int i = 1 ; i <= n ; ++i)
    {
        for (int j : v[i])
        {
            if (bridges.count({i, j})) continue;
            w[i].push_back(j);
        }
    }
    std::fill(bl+1, bl+n+1, 0);
    dfs(b);
    if (!bl[e])
    {
        std::cout << -1 << '\n';
        return;
    }

    for (int i : bcc)
    {
        for (int j : w[i])
        {
            int x = std::min(i, j);
            int y = std::max(i, j);
            // std::cout << "multi: " << x << ' ' << y << ' ' << multi[x][y] << '\n';
            if (call[x][y]) continue;
            call[x][y] = 1;
            if (multi[x][y])
            {
                g[x].push_back({y, 0});
                g[y].push_back({x, 0});
                continue;
            }
            findDists(x, y);
        }
    }

    dijkstra();
    int currNode = e, edges = 0;
    for (int i = 1 ; i <= n ; ++i)
    {
        if (currD2[e][edges] > currD2[e][i]) edges = i;
    }

    int ans1 = currD2[e][edges];
    // std::cout << "here11: " << edges << ' ' << currD2[e][edges] << '\n';
    while (currNode != b)
    {
        ans.push_back(currNode);
        currNode = from[currNode][edges];
        --edges;
    }
    ans.push_back(b);
    std::reverse(ans.begin(), ans.end());
    std::cout << ans1 << ' ' << ans.size()-1 << '\n';
    for (int i : ans) std::cout << i-1 << ' ';
    std::cout << '\n';
}

void read()
{
    int x, y;
    std::cin >> n >> m >> b >> e; ++b; ++e;
    for (int i = 1 ; i <= m ; ++i)
    {
        std::cin >> x >> y; ++x; ++y;
        if (x == y) continue;
        v[x].push_back(y);
        v[y].push_back(x);
        --multi[std::min(x, y)][std::max(x, y)];
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

signed main()
{
    fastIO();
    read();
    solve();

    return 0;
}

/*
7 10 0 6
0 1
0 2
1 1
1 3
2 3
3 4
3 4
4 5
4 6
5 6
*/
