// Gumza, ti li si be

#include <algorithm>
#include <iostream>
#include <unordered_set>
#define int long long

const int maxn = 1000000 + 10;
const int inf = 2e9;

std::unordered_set < int > s;
int key(int x, int y, int type)
{
    return type-1 + 2*y + 2*maxn*x;
}

std::pair < int, int > dpApples[2][maxn];
std::pair < int, int > dpPears[2][maxn];
std::pair < int, int > cmp(std::pair < int, int > x, std::pair < int, int > y)
{
    if (x.first > y.first) return x;
    if (x.first < y.first) return y;
    if (x.second > y.second) return x;
    return y;
}
int n;

void solve()
{
    for (int i = n ; i >= 1 ; --i)
    {
        for (int j = n ; j >= 1 ; --j)
        {
            std::pair < int, int > up, left;
            up = dpApples[(i+1)&1][j];
            left = dpApples[i&1][j+1];
            up.first += (s.count(key(i, j, 1)) || s.count(key(i, j, 2)));
            left.first += (s.count(key(i, j, 1)) || s.count(key(i, j, 2)));
            up.second += s.count(key(i, j, 1));
            up.second -= s.count(key(i, j, 2));
            left.second += s.count(key(i, j, 1));
            left.second -= s.count(key(i, j, 2));
            dpApples[i&1][j] = cmp(up, left);

            up = dpPears[(i+1)&1][j];
            left = dpPears[i&1][j+1];
            up.first += (s.count(key(i, j, 1)) || s.count(key(i, j, 2)));
            left.first += (s.count(key(i, j, 1)) || s.count(key(i, j, 2)));
            up.second += s.count(key(i, j, 2));
            up.second -= s.count(key(i, j, 1));
            left.second += s.count(key(i, j, 2));
            left.second -= s.count(key(i, j, 1));
            dpPears[i&1][j] = cmp(up, left);
        }
    }

    std::pair < int, int > ans = cmp(dpApples[1][1], dpPears[1][1]);
    std::cout << ans.first << ' ' << ans.second << '\n';
}

void read()
{
    int x, y, type;
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> x >> y >> type;
        s.insert(key(x, y, type));
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

signed main()
{
    fastIO();
    read();
    solve();

    return 0;
}

/*
4
1 2 1
2 1 2
3 1 1
4 3 2
*/
