// Gumza, ti li si be

#include <algorithm>
#include <iostream>
#include <cassert>
#include <stack>
#include <queue>
#define int long long

const int maxn = 1000000 + 10;
const int inf = 2e9;

struct Segment
{
    int l, r, len, h, type;

    inline friend bool operator == (Segment a, Segment b)
    {
        return a.l == b.l && a.r == b.r && a.len == b.len && a.h == b.h && a.type == b.type;
    }

    inline friend bool operator != (Segment a, Segment b)
    {
        return !(a == b);
    }

    inline friend bool operator < (Segment a, Segment b)
    {
        return (a.len > b.len);
    }
};

std::priority_queue < Segment > pq;
std::stack < int > st;
int a[maxn], n, k, ans;
int next[maxn], prev[maxn];
int nextEq[maxn], prevEq[maxn];

void add(Segment top)
{
    // std::cout << "add: " << top.type << ' ' << top.l << ' ' << top.r << ' ' << top.h << ' ' << top.len << ' ' << k << '\n';
    ans += top.type * std::min(top.h, k / top.len);
    // std::cout << "added: " << ans << '\n';
    if (k / top.len >= top.h)
    {
        int prevPos;
        int nextPos;
        if (a[top.l-1] == std::min(a[top.l-1], a[top.r+1])) prevPos = prevEq[top.l-1];
        else prevPos = top.l;

        if (a[top.r+1] == std::min(a[top.l-1], a[top.r+1])) nextPos = nextEq[top.r+1];
        else nextPos = top.r;

        if (top.l == 1) prevPos = 1;
        if (top.r == n) nextPos = n;
        // std::cout << "insert: " << prevPos << ' ' << nextPos << '\n';
        if (!(prevPos == 0 || nextPos == 0 || (prevPos == 1 && nextPos == n) || a[prevPos-1] <= a[prevPos] || a[nextPos+1] <= a[nextPos]))
        {
            // std::cout << "pushing\n";
            pq.push({prevPos, nextPos, nextPos - prevPos + 1, std::min(a[prevPos-1] - a[prevPos], a[nextPos+1] - a[nextPos]), ((prevPos == 1 || nextPos == n) ? 1 : 2)});
        }
    }
    k -= top.len * std::min(top.h, k / top.len);
    // std::cout << "left operations: " << k << '\n';
}

void solve()
{
    a[0] = a[n+1] = inf;
    st.push(0);
    for (int i = 1 ; i <= n+1 ; ++i)
    {
        while (a[i] > a[st.top()])
        {
            next[st.top()] = i;
            st.pop();
        }
        st.push(i);
    }
    st.pop();

    for (int i = n ; i >= 0 ; --i)
    {
        while (a[i] > a[st.top()])
        {
            prev[st.top()] = i;
            st.pop();
        }
        st.push(i);
    }

    /*for (int i = 1 ; i <= n ; ++i)
    {
        std::cout << i << ": " << prev[i] << ' ' << next[i] << '\n';
    }*/

    int last = 1;
    for (int i = 1 ; i <= n+1 ; ++i)
    {
        if (i != 1 && a[i] != a[i-1])
        {
            if (a[last] < a[last-1] && a[i-1] < a[i])
            {
                pq.push({last, i-1, i - last, std::min(a[last-1] - a[last], a[i] - a[i-1]), ((last == 1 || i == n+1) ? 1 : 2)});
                // std::cout << "push: " << last << ' ' << i-1 << '\n';
            }
            last = i;
        }
        prevEq[i] = last;
    }

    last = n;
    for (int i = n ; i >= 1 ; --i)
    {
        if (a[i] != a[i+1]) last = i;
        nextEq[i] = last;
    }

    prevEq[0] = nextEq[0] = 0;
    prevEq[n+1] = nextEq[n+1] = 0;

    int steps = 0;
    ans = 0; // std::cout << "before while: " << k << ' ' << pq.top().len << '\n';
    while (!pq.empty() && k >= pq.top().len)
    {
        // std::cout << "heeere: " << pq.size() << ' ' << pq.top().len << ' ' << pq.top().type << ' ' << pq.top().l << ' ' << pq.top().r << '\n';
        if (pq.size() == 1)
        {
            Segment top = pq.top(); pq.pop();
            add(top);
            continue;
        }

        if (pq.size() == 2)
        {
            // std::cout << "2 pops: " << pq.size() << '\n';
            Segment top1 = pq.top(); pq.pop();
            Segment top2 = pq.top(); pq.pop();
            // std::cout << "top lens: " << top1.len << ' ' << top2.len << ' ' << top1.type << ' ' << top2.type << '\n';
            if (top1.type == top2.type)
            {
                pq.push(top2);
                add(top1);
            } else
            {
                if (top1.type == 2)
                {
                    add(top1);
                    pq.push(top2);
                }
                else
                {
                    if (k >= top2.len)
                    {
                        pq.push(top1);
                        add(top2);
                    } else
                    {
                        pq.push(top2);
                        add(top1);
                    }
                }
            }

            continue;
        }

        // std::cout << "3 pops: " << pq.size() << '\n';
        Segment top1 = pq.top(); pq.pop();
        Segment top2 = pq.top(); pq.pop();
        Segment top3 = pq.top(); pq.pop();
        // std::cout << "types: " << top1.type << ' ' << top2.type << ' ' << top3.type << '\n';
        if (top1.type == top2.type && top2.type == top3.type)
        {
            assert(top1.type == 2);
            pq.push(top2);
            pq.push(top3);
            add(top1);
            continue;
        }
        Segment order1 = top1, order2 = top2, order3 = top3;
        if (order1 < order2) std::swap(order1, order2);
        if (order1 < order3) std::swap(order1, order3);
        if (order2 < order3) std::swap(order2, order3);
        if (order1.len + order2.len < order3.len && order1.type == 1 && order2.type == 1)
        {
            add(order1);
            add(order2);
            pq.push(order3);
            continue;
        }

        Segment min1 = {0, 0, inf, 0, 1}, min2 = {0, 0, inf, 0, 2};

        if (top1.type == 1) min1 = std::max(min1, top1);
        else min2 = std::max(min2, top1);

        if (top2.type == 1) min1 = std::max(min1, top2);
        else min2 = std::max(min2, top2);

        if (top3.type == 1) min1 = std::max(min1, top3);
        else min2 = std::max(min2, top3);

        // std::cout << "min1: " << min1.l << ' ' << min1.r << ' ' << min1.len << '\n';
        // std::cout << "top3: " << top3.l << ' ' << top3.r << ' ' << top3.len << ' ' << top3.type << '\n';
        assert(min1.l != 0);
        assert(min2.l != 0);
        bool bl = 0;
        if (top1 != min1 && top1 != min2) pq.push(top1), assert(!bl),/*, std::cout << "recover: " << top1.l << ' ' << top1.r << '\n'*/ bl = 1;
        if (top2 != min1 && top2 != min2) pq.push(top2), assert(!bl),/*, std::cout << "recover: " << top2.l << ' ' << top2.r << '\n'*/ bl = 1;
        if (top3 != min1 && top3 != min2) pq.push(top3), assert(!bl),/*, std::cout << "recover: " << top3.l << ' ' << top3.r << '\n'*/ bl = 1;
        if (!bl)
        {
            int cnt = (top1 == min1) + (top2 == min1) + (top3 == min1);
            if (cnt == 2) pq.push(min1);
            else pq.push(min2);
        }

        if (min1 < min2) std::swap(min1, min2);
        top1 = min1;
        top2 = min2;

        if (top1.type == 2)
        {
            add(top1);
            pq.push(top2);
        }
        else
        {
            if (std::min(top1.h, k / top1.len) <= 2*std::min(top2.h, k / top2.len))
            {
                pq.push(top1);
                add(top2);
            } else
            {
                pq.push(top2);
                add(top1);
            }
        }
    }

    assert(k >= 0);

    int atFirst = 0;
    for (int i = 1 ; i <= n-1 ; ++i)
    {
        atFirst += abs(a[i] - a[i+1]);
    }

    if (n > 15 && atFirst - ans == 0) exit(-1);
    std::cout << std::max(0ll, atFirst - ans) << '\n';
}

void read()
{
    std::cin >> n >> k;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

void reset()
{
    while (!st.empty()) st.pop();
    while (!pq.empty()) pq.pop();
    std::fill(prev+1, prev+1+n, 0);
    std::fill(prevEq+1, prevEq+1+n, 0);
    std::fill(next+1, next+1+n, 0);
    std::fill(nextEq+1, nextEq+1+n, 0);
}

int tests;
signed main()
{
    fastIO();
    std::cin >> tests;

    while (tests--)
    {
        reset();
        read();
        solve();
    }

    return 0;
}

/**

1
18 22
3 3 2 6 5 5 4 3 4 5 6 3 2 1 6 3 3 2
3 3 3 6 5 5 5 5 5 5 6 3 3 3 6 3 3 2 = 8
4 4 4 6 5 5 5 5 5 5 6 6 6 6 6 3 3 2 = 12
4 4 4 6 5 5 5 5 5 5 6 6 6 6 6 3 3 3 = 1
left operations: 1
ans: 7

6
6 2
6 3 3 3 4 3
6 3
6 3 3 3 4 3
6 4
4 3 3 3 4 3
18 22
3 3 2 6 5 5 4 3 4 5 6 3 2 1 6 3 3 2
7 4
2 4 3 3 3 4 2
2 10
1 5

4
3
0
7
2
0

1
18 22
3 3 2 6 5 5 4 3 4 5 6 3 2 1 6 3 3 2

*/
