#include <iostream>
#include <utility>
#include <vector>
#include <queue>
#include <stack>
#define endl '\n'
using namespace std;

const int MAXN = 1000;
const int MAXM = 1000000;
const int INF = 1000000000;

int n, m, s, t;
bool used[MAXN + 5];
queue< pair<int, int> > q;
vector< pair<int, int> > G[MAXN + 5], g;
int d[MAXN + 5], mx[MAXN + 5], dist[MAXN + 5], prv[MAXN + 5];

int BFS(int u0, int v0, int i0)
{
    for (int u = 1; u <= n; ++ u)
    {
        used[u] = false;
    }

    int u, d;
    q.push({u0, 0});
    used[u0] = true;
    while (!q.empty())
    {
        u = q.front().first;
        d = q.front().second;
        q.pop();

        if (u == v0) return d;

        for (auto [v, i] : G[u])
        {
            if (!used[v] and i != i0)
            {
                used[v] = true;
                q.push({v, d + 1});
            }
        }
    }
}

void calc(int u)
{
    for (int u = 1; u <= n; ++ u)
    {
        dist[u] = INF;
        used[u] = false;
    }

    int d;
    mx[u] = prv[u] = dist[u] = 0;
    priority_queue< pair<int, int> > pq;
    pq.push({0, u});
    while (!pq.empty())
    {
        u = pq.top().second;
        d = -pq.top().first;
        pq.pop();

        used[u] = true;
        if (d > dist[u]) continue;
        for (auto [v, w] : G[u])
        {
            if (!used[v] and dist[u] - mx[u] + max(mx[u], w) + 1 < dist[v])
            {
                prv[v] = u;
                mx[v] = max(mx[u], w);
                dist[v] = dist[u] - mx[u] + max(mx[u], w) + 1;
                pq.push({-dist[v], v});
            }
        }
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m >> s >> t;
    s++; t++;

    for (int i = 1; i <= m; ++ i)
    {
        int u, v;
        cin >> u >> v;
        u++; v++;
        if (u == v) continue;
        G[u].push_back({v, i});
        G[v].push_back({u, i});
    }

    for (int u = 1; u <= n; ++ u)
    {
        g.clear();
        for (int v = 1; v <= n; ++ v)
        {
            d[v] = 0;
        }
        for (auto [v, i] : G[u])
        {
            if (d[v]) continue;
            d[v] = BFS(u, v, i);
            g.push_back({v, d[v]});
        }
        G[u] = g;
    }

    calc(s);

    if (dist[t] == INF) cout << -1 << endl;
    else
    {
        cout << dist[t] - 1 << " " ;

        int cnt = 0;
        stack<int> st;
        while (t != 0)
        {
            cnt++;
            st.push(t - 1);
            t = prv[t];
        }

        cout << cnt - 1 << endl;

        while (!st.empty())
        {
            cout << st.top() << " ";
            st.pop();
        }
        cout << endl;
    }

    return 0;
}
