#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#include <queue>
#include <stack>
#define endl '\n'
using namespace std;

const int MAXN = 100000;
const int MAXM = 1000000;
const int INF = 1000000000;

int n, m, s, t;
bool used[MAXN + 5];
queue< pair<int, int> > q;
int d[MAXN + 5], prv[MAXN + 5];
vector< pair<int, int> > G[MAXN + 5], g[MAXN + 5];

int BFS1(int u0, int v0, int i0)
{
    for (int i = 1; i <= n; ++ i)
    {
        used[i] = false;
    }

    int u, d, d0 = INF;
    q.push({u0, 0});
    used[u0] = true;
    while (!q.empty())
    {
        u = q.front().first;
        d = q.front().second;
        q.pop();

        if (u == v0) d0 = d;

        for (auto [v, i] : g[u])
        {
            if (!used[v] and i != i0)
            {
                used[v] = true;
                q.push({v, d + 1});
            }
        }
    }

    return d0;
}

int BFS(int u0, int v0, int w0)
{
    for (int i = 1; i <= n; ++ i)
    {
        used[i] = false;
    }

    int u, d, d0 = INF;
    q.push({u0, 0});
    used[u0] = true;
    prv[u0] = 0;
    while (!q.empty())
    {
        u = q.front().first;
        d = q.front().second;
        q.pop();

        if (u == v0) d0 = d + w0 - 1;

        for (auto [v, w] : G[u])
        {
            if (!used[v] and w <= w0)
            {
                prv[v] = u;
                used[v] = true;
                q.push({v, d + 1});
            }
        }
    }

    return d0;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m >> s >> t;
    s++; t++;

    for (int i = 1; i <= m; ++ i)
    {
        int u, v;
        cin >> u >> v;
        u++; v++;
        G[u].push_back({v, i});
        G[v].push_back({u, i});
    }

    for (int u = 1; u <= n; ++ u)
    {
        for (auto [v, i] : G[u])
        {
            if (u == v) continue;
            g[u].push_back({v, i});
        }
    }

    vector<int> c;
    for (int u = 1; u <= n; ++ u)
    {
        G[u].clear();
        for (int v = 1; v <= n; ++ v)
        {
            d[v] = 0;
        }
        for (auto [v, i] : g[u])
        {
            if (d[v]) continue;
            d[v] = BFS1(u, v, i);
            G[u].push_back({v, d[v]});
            c.push_back(d[v]);
        }
    }

    sort(c.begin(), c.end());
    auto it = unique(c.begin(), c.end());
    c.resize(distance(c.begin(), it));

    int mn = INF;
    vector<int> ans;
    for (int i = 0; i < c.size(); ++ i)
    {
        int p = BFS(s, t, c[i]);
        if (p < mn)
        {
            mn = p;
            ans.clear();
            int t0 = t;
            while (t0)
            {
                ans.push_back(t0);
                t0 = prv[t0];
            }
        }
    }

    if (mn == INF)
    {
        cout << -1 << endl;
        return 0;
    }

    cout << mn << " " << ans.size() - 1 << endl;

    reverse(ans.begin(), ans.end());

    for (auto u : ans)
    {
        cout << u - 1 << " ";
    }
    cout << endl;

    return 0;
}
