#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#include <queue>
#define endl '\n'
using namespace std;

const int MAXN = 1000000;
const int INF = 1000000001;

int n;
int v[MAXN + 5];

long long sum(int h)
{
    long long ret = 0;
    for (int i = 1; i <= n; ++ i)
    {
        ret += max(h - v[i], 0);
    }
    return ret;
}

void solve()
{
    long long k;
    cin >> n >> k;

    int mn = INF;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> v[i];
        mn = min(mn, v[i]);
    }

    int l = mn, r = INF, mid;
    while (r - l > 1)
    {
        mid = (l + r) / 2;
        if (sum(mid) <= k) l = mid;
        else r = mid;
    }

    k -= sum(l);
    for (int i = 1; i <= n; ++ i)
    {
        v[i] = max(v[i], l);
    }

    while (k)
    {
        int prv = INF;
        priority_queue< pair<int, pair<int, int> > > pq;
        int curr = v[1], cnt = 1;
        for (int i = 2; i <= n; ++ i)
        {
            if (v[i] == curr) cnt++;
            else
            {
                if (prv > curr and curr < v[i])
                {
                    if (prv == INF)
                    {
                        pq.push({min(v[i] - curr, (int)(k / cnt)), {-cnt * min(v[i] - curr, (int)(k / cnt)), i - cnt}});
                    }
                    else
                    {
                        pq.push({2 * min(min(v[i] - curr, prv - curr), (int)(k / cnt)), {cnt * min(min(v[i] - curr, prv - curr), (int)(k / cnt)), i - cnt}});
                    }
                }
                prv = curr;
                curr = v[i];
                cnt = 1;
            }
        }
        if (prv > curr)
        {
            pq.push({min(prv - curr, (int)(k / cnt)), {-cnt * min(prv - curr, (int)(k / cnt)), n + 1 - cnt}});
        }

        while (!pq.empty() and pq.top().first != 0 and (pq.top().second.first < 0 ? -pq.top().second.first / pq.top().first : 2 * pq.top().second.first / pq.top().first) > k) pq.pop();

        if (pq.empty() or pq.top().first == 0) break;

        cnt = -pq.top().second.first / pq.top().first;
        int fi = pq.top().second.second;
        int se = fi + cnt - 1;

        int t;
        if (fi == 1) t = v[se + 1] - v[fi];
        else if (se == n) t = v[fi - 1] - v[se];
        else t = min(v[se + 1] - v[fi], v[fi - 1] - v[se]);

        t = min(t, (int)(k / cnt));
        k -= t * cnt;
        for (int i = fi; i < fi + cnt; ++ i)
        {
            v[i] += t;
        }
    }

    long long ans = 0;
    for (int i = 1; i < n; ++ i)
    {
        ans += (v[i] > v[i + 1] ? v[i] - v[i + 1] : v[i + 1] - v[i]);
    }

    cout << ans << endl;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int t;
    cin >> t;

    while (t--)
    {
        solve();
    }

    return 0;
}
