#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#include <ctime>
#include <queue>
#define endl '\n'
using namespace std;

const int MAXN = 100;
const int INF = 1000000001;

int n;
time_t start;
int v[MAXN + 5];
long long dp[MAXN + 5][2 * MAXN + 5][2 * MAXN + 5];

long long sum(int h)
{
    long long ret = 0;
    for (int i = 1; i <= n; ++ i)
    {
        ret += max(h - v[i], 0);
    }
    return ret;
}

void solve()
{
    long long k;
    cin >> n >> k;

    int mn = INF;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> v[i];
        mn = min(mn, v[i]);
    }

    for (int i = 1; i <= k; ++ i)
    {
        dp[1][i][i] = 0;
    }

    long long ans = 1ll * n * INF;
    for (int i = 2; i <= n; ++ i)
    {
        for (int j = 0; j <= k; ++ j)
        {
            for (int s = 0; s <= j; ++ s)
            {
                dp[i][j][s] = -1;
                for (int t = 0; t <= j - s; ++ t)
                {
                    if (dp[i][j][s] == -1) dp[i][j][s] = dp[i - 1][j - s][t] + (v[i - 1] + t - v[i] - s > 0 ? v[i - 1] + t - v[i] - s : v[i] + s - v[i - 1] - t);
                    dp[i][j][s] = min(dp[i][j][s], dp[i - 1][j - s][t] + (v[i - 1] + t - v[i] - s > 0 ? v[i - 1] + t - v[i] - s : v[i] + s - v[i - 1] - t));
                }
                if (i == n) ans = min(ans, dp[i][j][s]);
                if (clock() - start > 0.63 * CLOCKS_PER_SEC)
                {
                    cout << ans << endl;
                    return;
                }
            }
        }
    }

    cout << ans << endl;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
    
    start = clock();

    int t;
    cin >> t;

    while (t--)
    {
        solve();
    }

    return 0;
}
