#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 1e5, inf = 1e7;
int n, m, s, t, dp[maxn], used[maxn], st[maxn], vis[maxn], imp[maxn];

vector < pair < int, int >  > g[maxn], ng[maxn];

struct edge
{
    int v, u;
} e[maxn * 10];

void add_edge(int v, int u, int idx)
{
    g[v].push_back({u, idx});
    g[u].push_back({v, idx});
    ng[v].push_back({u, idx});
    ng[u].push_back({v, idx});
}

void bfs(int idx)
{
    for (int i = 0; i < n; i ++)
        vis[i] = inf;

    queue < int > q;
    q.push(t);
    vis[t] = 0;
    while(!q.empty())
    {
        int v = q.front();
        q.pop();
        for (int i = 0; i < g[v].size(); i ++)
        {
            if (g[v][i].second == idx)
                continue;
            if (vis[g[v][i].first] == inf)
            {
                vis[g[v][i].first] = vis[v] + 1;
                q.push(g[v][i].first);
            }
        }
    }
}
void calc_st()
{
    for (int i = 0; i < n; i ++)
        st[i] = 0;
    for (int i = 1; i <= m; i ++)
    {
        bfs(i);
        for (int j = 0; j < n; j ++)
        {
            st[j] = max(st[j], vis[j]);
        }
    }
}


int fr[maxn];
bool check(int x)
{
    for (int i = 0; i < n; i ++)
        used[i] = -1;

    if (st[s] > x)
        return false;
    queue < int > q;
    q.push(s);
    fr[s] = -1;
    used[s] = 0;
    while(!q.empty())
    {
        int v = q.front();
        q.pop();
        for (pair < int, int > pp : ng[v])
        {
            if (used[pp.first] == -1)
            {
                int wd = used[v] + 1 + st[pp.first];
                if (wd <= x)
                {
                    fr[pp.first] = v;
                    used[pp.first] = used[v] + 1;
                    q.push(pp.first);
                }
            }

        }
    }

    if (used[t] == -1)
        return false;
    return true;
}

void precalc()
{
    queue < int > q;
    q.push(t);
    for (int i =0; i < n; i ++)
        vis[i] = inf;
    vis[t] = 0;
    while(!q.empty())
    {
        int v = q.front();
        q.pop();
        for (int i = 0; i < g[v].size(); i ++)
        {
            int u = g[v][i].first;
            if (vis[u] != inf)
                continue;
            imp[g[v][i].second] = 1;
            vis[u] = vis[v] + 1;
            q.push(u);
        }
    }
}
void solve()
{
    cin >> n >> m >> s >> t;
    for (int i = 1; i <= m; i ++)
    {
        cin >> e[i].v >> e[i].u;
        add_edge(e[i].v, e[i].u, i);
    }

    for (int i = 0; i < n; i ++)
        used[i] = -1, dp[i] = inf;

    precalc();
    calc_st();

    int lf = 0, rf = inf;

    while(lf <= rf)
    {
        int mf = (lf + rf) / 2;
        if (check(mf))
            rf = mf - 1;
        else
            lf = mf + 1;
    }

    if (lf == inf + 1)
    {
        cout << -1 << endl;
        return;
    }

    check(lf);
    vector < int > path;
    int v = t;
    path.push_back(v);
    while(fr[v] != -1)
    {
        v = fr[v];
        path.push_back(v);
    }

    reverse(path.begin(), path.end());
    cout << lf << " " << path.size() - 1 << endl;
    for (int i = 0; i < path.size(); i ++)
        cout << path[i] << " ";
    cout << endl;
}

int main ()
{
    solve();
    return 0;
}
